##=============================================================================
## Curso de Sensometria - Estatística UFPR
## Trabalho 1
## 
##                                                           Grupo do Chocolate
##                                                                   05/05/2015
##=============================================================================

autores <- c("Ana Carolina", "Ana Flávia", "Carolina Stupka", "Cintia Consulin", 
             "Damiane Ferreira", "Eduardo Junior", "Henrique Laureano",
             "Jhosefer da Silva", "Konstanz Winter", "Lucas Bozza",
             "Michele Mottin", "Morlan Luigi", "Pamella Feliciano",
             "Renato Brito", "Tiago Teixeira")

##=============================================================================
## Lendo dados

##--------------------------------------------
## renomeando dados
dados <- read.table("data.csv", header=TRUE, sep = ";", dec=",")
names(dados) <- c("aval", "atr", "trat", "resp")

##--------------------------------------------
## Descodificando as marcas
code.a <- c(389, 411, 598); code.b <- c(724, 145, 917)
for(i in code.a) dados$trat[dados$trat == i] <- "Garoto"
for(i in code.b) dados$trat[dados$trat == i] <- "Nestle"
dados$trat[dados$trat != "Garoto" & dados$trat != "Nestle"] <- "Lacta"
dados$trat <- as.factor(dados$trat)

##--------------------------------------------
## Juntando avaliadores com repetiçoes incompletas
dados$aval <- gsub("^(\\w+) .*$", "\\1", dados$aval)
dados$aval[dados$aval == "Jhosefer" | dados$aval == "Ana"] <- "Jhosefer*" 
dados$aval[dados$aval == "Lucas" | dados$aval == "Carolina"] <- "Lucas*" 
dados$aval[dados$aval == "Pamela" | dados$aval == "Konstanz"] <- "Pamela*"
dados$aval <- as.factor(dados$aval)

##=============================================================================
## Anova por atributo/avaliando o efeito de interação

##--------------------------------------------
## Selecionando dados apenas de um atributo
da <- subset(dados, atr == "Ondulação")

##--------------------------------------------
## Analise de variancia por atributo
m0 <- aov(resp ~ aval * trat, data=da)
anova(m0)

##--------------------------------------------
## Gráfico de interação
with(da, interaction.plot(trat, aval, resp))

##--------------------------------------------
## Analise de variancia por atributo por avaliador

##--------------------------------------------
## Organizando os dados
da <- da[with(da, order(aval, trat)),] ## Ordenando os dados
da$rep <- paste(da$aval, 1:3, sep="")  ## Criando a coluna rep
da$rep <- as.factor(da$rep)            ## Transformando em fator

## Análise de variância por atributo e por avaliador
db <- subset(da, aval == "Eduardo")
m0 <- aov(resp ~ trat + rep, data = db)
anova(m0)

##=============================================================================
## Comparando os tratamentos (por atributo)

##--------------------------------------------
## Modelo final (sem o efeito significativo de interação)
mod1 <- aov(resp ~ aval + trat, data=da)

##--------------------------------------------
## Comparacoes multiplas 
tk <- TukeyHSD(mod1, "trat")
plot(tk)

##--------------------------------------------
## Resumo com letras
require(multcomp)
g0 <- summary(glht(mod1, linfct = mcp(trat = "Tukey")))
cld(g0)
